terraform {
  required_providers {
    helm = {
      source = "hashicorp/helm"
      version = "~> 2.17"
    }
  }
}

resource "helm_release" "this" {
  name = var.release_name
  repository = var.chart_repo
  chart = var.chart_name
  version = var.chart_version
  namespace = var.namespace
  create_namespace = var.create_namespace
  recreate_pods = var.recreate_pods
  dependency_update = var.dependency_update
  force_update = var.force_update
  wait = var.wait
  values = local.values_content

  dynamic "set" {
    for_each = local.set_values
    content {
      name = set.key
      value = set.value
    }
  }

  dynamic "set_sensitive" {
    for_each = local.set_sensitive_values
    content {
      name = set_sensitive.key
      value = set_sensitive.value
    }
  }
}
